;;;**************************   -  -> Zigzag ******************************

;;; error function
(defun *error* (msg)
 (setq msg "Function Abort")
 (princ)
 (princ msg)
 (princ)
)

;  
(defun SetOpt ()
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

;  
(defun RetOpt ()
	(setvar "BLIPMODE" sblip)
	(setvar "CMDECHO" scmde)
)

;  OSNAP
(defun Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun Osnap_On  ()
	(setvar "OSMODE" sosnapm)
)
;;;**********************************************

(defun $drwLinBreak1 (sp ep scale SS / angL L1 p1 p2 p2_1 p3 p3_1 p4)
;      
    
    (setq angL (angle sp ep))
    (setq L1 (distance sp ep))
    (osnap_off)
    (if (<= L1 (* 5 scale))
        (command "_pline" sp ep "")
        (progn
            (setq p1 (polar sp angL (- (/ L1 2) scale)))
            (setq p2_1 (polar p1 angL (/ scale 2)))
            (setq p2 (polar p2_1 (+ angL (dtr 90)) scale))
            (setq p3_1 (polar p2_1 angL scale))
            (setq p3 (polar p3_1 (- angL (dtr 90)) scale))
            (setq p4 (polar p3_1 angL (/ scale 2)))
            (command "_pline" sp p1 p2 p3 p4 ep "")
        )
    )
    (osnap_on)
    (ssadd (entlast) SS)
    t SS	 ;  
)

(defun C:Zigzag ( / pt1 pt2 L angL scale nSegm lLeft SS SS1 sp ep )
;     

    (SetOpt)

    (setq pt1 (getpoint "\n   : "))
    (setq pt2 (getpoint pt1 "\n   : ")) ;pt1 -    
    (setq L (distance pt1 pt2))
    (setq Scale (* 4 (getvar "dimscale")))	;  
            						;    

	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 4)
	)

    (if (< L (* 6 scale))
        (progn
            (princ)
            (print "   ...")
        )
        (progn
            (setq angL (angle pt1 pt2))
            (setq nSegm (fix (/ L (* 6 scale))))
            (setq lLeft L)
            (setq sp pt1)
            (setq SS (ssadd))
	        (while (> lLeft (* 6 scale))
                (setq ep (polar sp angL (* 6 scale)))
                (setq SS ($drwLinBreak1 sp ep scale SS))
                (setq sp ep)
                (setq lLeft (- lLeft (* 6 scale)))
              )
            (setq SS ($drwLinBreak1 sp pt2 scale SS))
            (setq SS1 (ssadd))
            (ssadd (entlast) SS1)
            (command "_pedit" SS1 "Join" SS "" "")
        )
    )
	(RetOpt)
(princ)
)
;;;********************************************************************